Compare commits

..

No commits in common. "main" and "main" have entirely different histories.
main ... main

11 changed files with 136 additions and 380 deletions

View File

@ -2,23 +2,15 @@ services:
laconicd: laconicd:
restart: unless-stopped restart: unless-stopped
image: cerc/laconicd:local image: cerc/laconicd:local
command: ["bash", "/scripts/init.sh"] command: ["bash", "/docker-entrypoint-scripts.d/create-fixturenet.sh"]
environment: environment:
TEST_AUCTION_ENABLED: ${TEST_AUCTION_ENABLED:-false} TEST_AUCTION_ENABLED: ${TEST_AUCTION_ENABLED:-false}
TEST_REGISTRY_EXPIRY: ${TEST_REGISTRY_EXPIRY:-false} TEST_REGISTRY_EXPIRY: ${TEST_REGISTRY_EXPIRY:-false}
ONBOARDING_ENABLED: ${ONBOARDING_ENABLED:-false} ONBOARDING_ENABLED: ${ONBOARDING_ENABLED:-false}
STAKING_AMOUNT: ${STAKING_AMOUNT:-1000000000000000}
AUTHORITY_AUCTION_ENABLED: ${AUTHORITY_AUCTION_ENABLED}
AUTHORITY_AUCTION_COMMITS_DURATION: ${AUTHORITY_AUCTION_COMMITS_DURATION}
AUTHORITY_AUCTION_REVEALS_DURATION: ${AUTHORITY_AUCTION_REVEALS_DURATION}
AUTHORITY_GRACE_PERIOD: ${AUTHORITY_GRACE_PERIOD}
GENESIS_FILE: /var/tmp/genesis.json
MONIKER: ${MONIKER:-localtestnet}
CHAINID: ${CHAINID:-laconic_9000-1}
MIN_GAS_PRICE: ${MIN_GAS_PRICE:-0.001}
volumes: volumes:
- laconicd-data:/root/.laconicd - laconicd-data:/root/.laconicd
- genesis-config:/var/tmp - genesis-config:/var/tmp
- ../config/fixturenet-laconicd/create-fixturenet.sh:/docker-entrypoint-scripts.d/create-fixturenet.sh
ports: ports:
- "6060" - "6060"
- "26657" - "26657"

View File

@ -0,0 +1,119 @@
#!/bin/bash
KEY="alice"
CHAINID="laconic_9000-1"
MONIKER="localtestnet"
KEYRING="test"
LOGLEVEL="${LOGLEVEL:-info}"
input_genesis_file=/var/tmp/genesis.json
if [ "$1" == "clean" ] || [ ! -d "$HOME/.laconicd/data/blockstore.db" ]; then
# validate dependencies are installed
command -v jq > /dev/null 2>&1 || {
echo >&2 "jq not installed. More info: https://stedolan.github.io/jq/download/"
exit 1
}
# remove existing daemon and client
rm -rf $HOME/.laconicd/*
if [ -n "`which make`" ]; then
make install
fi
laconicd config set client chain-id $CHAINID
laconicd config set client keyring-backend $KEYRING
# if $KEY exists it should be deleted
laconicd keys add $KEY --keyring-backend $KEYRING
# Set moniker and chain-id for Ethermint (Moniker can be anything, chain-id must be an integer)
laconicd init $MONIKER --chain-id $CHAINID --default-denom alnt
if [ -f ${input_genesis_file} ]; then
# Use provided genesis config
cp $input_genesis_file $HOME/.laconicd/config/genesis.json
fi
update_genesis() {
jq "$1" $HOME/.laconicd/config/genesis.json > $HOME/.laconicd/config/tmp_genesis.json &&
mv $HOME/.laconicd/config/tmp_genesis.json $HOME/.laconicd/config/genesis.json
}
if [[ "$TEST_REGISTRY_EXPIRY" == "true" ]]; then
echo "Setting timers for expiry tests."
update_genesis '.app_state["registry"]["params"]["record_rent_duration"]="60s"'
update_genesis '.app_state["registry"]["params"]["authority_grace_period"]="60s"'
update_genesis '.app_state["registry"]["params"]["authority_rent_duration"]="60s"'
fi
if [[ "$TEST_AUCTION_ENABLED" == "true" ]]; then
echo "Enabling auction and setting timers."
update_genesis '.app_state["registry"]["params"]["authority_auction_enabled"]=true'
update_genesis '.app_state["registry"]["params"]["authority_rent_duration"]="60s"'
update_genesis '.app_state["registry"]["params"]["authority_grace_period"]="300s"'
update_genesis '.app_state["registry"]["params"]["authority_auction_commits_duration"]="60s"'
update_genesis '.app_state["registry"]["params"]["authority_auction_reveals_duration"]="60s"'
fi
if [[ "$ONBOARDING_ENABLED" == "true" ]]; then
echo "Enabling validator onboarding."
update_genesis '.app_state["onboarding"]["params"]["onboarding_enabled"]=true'
fi
# increase block time (?)
update_genesis '.consensus["params"]["block"]["time_iota_ms"]="1000"'
# Set gas limit in genesis
update_genesis '.consensus["params"]["block"]["max_gas"]="10000000"'
# disable produce empty block
if [[ "$OSTYPE" == "darwin"* ]]; then
sed -i '' 's/create_empty_blocks = true/create_empty_blocks = false/g' $HOME/.laconicd/config/config.toml
else
sed -i 's/create_empty_blocks = true/create_empty_blocks = false/g' $HOME/.laconicd/config/config.toml
fi
# Enable telemetry (prometheus metrics: http://localhost:1317/metrics?format=prometheus)
if [[ "$OSTYPE" == "darwin"* ]]; then
sed -i '' 's/enabled = false/enabled = true/g' $HOME/.laconicd/config/app.toml
sed -i '' 's/prometheus-retention-time = 0/prometheus-retention-time = 60/g' $HOME/.laconicd/config/app.toml
sed -i '' 's/prometheus = false/prometheus = true/g' $HOME/.laconicd/config/config.toml
else
sed -i 's/enabled = false/enabled = true/g' $HOME/.laconicd/config/app.toml
sed -i 's/prometheus-retention-time = 0/prometheus-retention-time = 60/g' $HOME/.laconicd/config/app.toml
sed -i 's/prometheus = false/prometheus = true/g' $HOME/.laconicd/config/config.toml
fi
# Run this to allow requests from any origin
sed -i 's/cors_allowed_origins.*$/cors_allowed_origins = ["*"]/' $HOME/.laconicd/config/config.toml
# Allocate genesis accounts (cosmos formatted addresses)
# 10^30 alnt | 10^12 lnt
laconicd genesis add-genesis-account $KEY 1000000000000000000000000000000alnt --keyring-backend $KEYRING
# Sign genesis transaction
# 10^24 alnt | 10^6 lnt
laconicd genesis gentx $KEY 1000000000000000000000000alnt --keyring-backend $KEYRING --chain-id $CHAINID
# Collect genesis tx
laconicd genesis collect-gentxs
# Run this to ensure everything worked and that the genesis file is setup correctly
laconicd genesis validate
else
echo "Using existing database at $HOME/.laconicd. To replace, run '`basename $0` clean'"
fi
# Start the node (remove the --pruning=nothing flag if historical queries are not needed)
laconicd start \
--pruning=nothing \
--log_level $LOGLEVEL \
--minimum-gas-prices=1alnt \
--api.enable \
--rpc.laddr="tcp://0.0.0.0:26657" \
--gql-server --gql-playground

View File

@ -96,32 +96,9 @@ Instructions for running a laconicd fixturenet along with registry CLI and conso
```bash ```bash
# Optional # Optional
# Set to true to enable adding participants functionality of the onboarding module (default: false) # Set to true to enable adding participants functionality of the onboarding module
# (default: false)
ONBOARDING_ENABLED= ONBOARDING_ENABLED=
# Staking amount to use for the default validator account (default: 1000000000000000)
STAKING_AMOUNT=
# Enable authority auctions (default: false)
AUTHORITY_AUCTION_ENABLED=true
# Authority auctions commits duration (in secs) (default: 1hr)
AUTHORITY_AUCTION_COMMITS_DURATION=3600
# Authority auctions reveals duration (in secs) (default: 1hr)
AUTHORITY_AUCTION_REVEALS_DURATION=3600
# Authority grace period (set bond to authority within this) (in secs) (default: 2 * 1hr)
AUTHORITY_GRACE_PERIOD=7200
# Node moniker (default: "localtestnet")
MONIKER=
# Chain ID of the network (default: "laconic_9000-1")
CHAINID=
# Minimum gas price in alnt to accept for transactions (default: "0.001")
MIN_GAS_PRICE=
``` ```
* Inside the `laconic-console-deployment` deployment directory, open `config.env` file and set following env variables: * Inside the `laconic-console-deployment` deployment directory, open `config.env` file and set following env variables:
@ -138,13 +115,8 @@ Instructions for running a laconicd fixturenet along with registry CLI and conso
# Gas limit for txs (default: 200000) # Gas limit for txs (default: 200000)
CERC_LACONICD_GAS= CERC_LACONICD_GAS=
# Max fees for txs (default: 200alnt) # Max fees for txs (default: 200000alnt)
CERC_LACONICD_FEES= CERC_LACONICD_FEES=
# Gas price to use for txs (default: 0.001alnt)
# Use for auto fees calculation, gas and fees not required to be set in that case
# Reference: https://git.vdb.to/cerc-io/laconic-registry-cli#gas-and-fees
CERC_LACONICD_GASPRICE=
``` ```
## Start the deployment ## Start the deployment
@ -207,5 +179,5 @@ laconic-so deployment --dir laconic-console-deployment start
laconic-so deployment --dir fixturenet-laconicd-deployment stop --delete-volumes laconic-so deployment --dir fixturenet-laconicd-deployment stop --delete-volumes
# Remove deployment directory (deployment will have to be recreated for a re-run) # Remove deployment directory (deployment will have to be recreated for a re-run)
sudo rm -r fixturenet-laconicd-deployment rm -r fixturenet-laconicd-deployment
``` ```

View File

@ -1,94 +0,0 @@
#!/bin/bash
# Exit on error
set -e
set -u
# Check args
if [ "$#" -ne 3 ]; then
echo "Usage: $0 <subscribed-participants-csv> <participant-allocation> <validator-allocation>"
echo "Example: $0 /home/user/subscribed-participants.csv 1000000 1000000000000"
exit 1
fi
SUBSCRIBED_PARTICIPANTS_CSV="$1"
PARTICIPANT_ALLOCATION="$2"
VALIDATOR_ALLOCATION="$3"
STAGE1_GENESIS_DIR=stage1-genesis
# Create a temporary target directory
mkdir -p $STAGE1_GENESIS_DIR
# --------
# Parse the input CSV file to create stage1 onboarding module state
# Input CSV columns:
# 5: laconic_address, 6: nitro_address, 7: role, 8: hashed_subscriber_id, 11: funding_amount
stage1_participants_file="$STAGE1_GENESIS_DIR/stage1-participants.json"
jq -R -s --arg participant_allocation "$PARTICIPANT_ALLOCATION" --arg validator_allocation "$VALIDATOR_ALLOCATION" -f <(cat <<'EOF'
# Split the input into lines
split("\n") |
# Skip the first line (header) and filter out empty lines
.[1:] | map(select(length > 0)) |
# For each line, split it into fields by comma
map(split(",") | map(gsub("^\"|\"$"; ""))) |
# Create objects from the relevant fields
map({
cosmos_address: .[5],
nitro_address: .[6],
role: .[7],
kyc_id: .[8]
})
EOF
) < "$SUBSCRIBED_PARTICIPANTS_CSV" > "$stage1_participants_file"
echo "Exported participants for stage1 onboarding module state"
# --------
# Parse the input CSV file to calculate allocations on stage1
# Use provided input amounts if funding amount not present in the CSV
stage1_allocations_file="$STAGE1_GENESIS_DIR/stage1-allocations.json"
jq -R -s --arg participant_allocation "$PARTICIPANT_ALLOCATION" --arg validator_allocation "$VALIDATOR_ALLOCATION" -f <(cat <<'EOF'
# Split the input into lines
split("\n") |
# Skip the first line (header) and filter out empty lines
.[1:] | map(select(length > 0)) |
# For each line, split it into fields by comma
map(split(",") | map(gsub("^\"|\"$"; ""))) |
# Create objects from the relevant fields
map({
cosmos_address: .[5],
balance: (
if .[11] == "" or .[11] == null then
if .[7] == "validator" then $validator_allocation else $participant_allocation end
else .[11] end
)
})
EOF
) < "$SUBSCRIBED_PARTICIPANTS_CSV" > "$stage1_allocations_file"
echo "Calculated allocations for stage 1 chain"
# --------
# Run a script with cerc/laconicd:local to generate the genesis file
# with onboarding module state and given allocations
docker run -it \
-v ./$STAGE1_GENESIS_DIR:/root/.laconicd \
-v ./scripts:/scripts \
cerc/laconicd:local bash -c "/scripts/genesis.sh"
# Copy over the genesis file to output folder
OUTPUT_DIR=output
mkdir -p $OUTPUT_DIR
cp ./$STAGE1_GENESIS_DIR/config/genesis.json $OUTPUT_DIR/genesis.json
echo "Genesis file for stage1 written to $OUTPUT_DIR/genesis.json"
# --------
# Clean up
echo "Please remove the temporary data directory: sudo rm -rf $STAGE1_GENESIS_DIR"

View File

@ -1,50 +0,0 @@
#!/bin/bash
# Exit on error
set -e
set -u
# Check args
if [ "$#" -ne 2 ]; then
echo "Usage: $0 <stage1-participants-json> <stage1-allocations-json>"
echo "Example: $0 ./stage-participants.json ./stage1-allocations.json"
exit 1
fi
STAGE1_PARTICIPANTS_FILE="$1"
STAGE1_ALLOCATIONS_FILE="$2"
STAGE1_GENESIS_DIR=stage1-genesis
# Create a temporary target directory
mkdir -p $STAGE1_GENESIS_DIR
# --------
# Copy over the stage1-participants json file for genesis.sh to use
cp $STAGE1_PARTICIPANTS_FILE "$STAGE1_GENESIS_DIR/stage1-participants.json"
echo "Copied over stage1 participants json file to mount dir"
# Copy over the stage1-participants json file for genesis.sh to use
cp $STAGE1_ALLOCATIONS_FILE "$STAGE1_GENESIS_DIR/stage1-allocations.json"
echo "Copied over stage1 allocations json file to mount dir"
# --------
# Run a script with cerc/laconicd:local to generate the genesis file
# with onboarding module state and given allocations
docker run -it \
-v ./$STAGE1_GENESIS_DIR:/root/.laconicd \
-v ./scripts:/scripts \
cerc/laconicd:local bash -c "/scripts/genesis.sh"
# Copy over the genesis file to output folder
OUTPUT_DIR=output
mkdir -p $OUTPUT_DIR
cp ./$STAGE1_GENESIS_DIR/config/genesis.json $OUTPUT_DIR/genesis.json
echo "Genesis file for stage1 written to $OUTPUT_DIR/genesis.json"
# --------
# Clean up
echo "Please remove the temporary data directory: sudo rm -rf $STAGE1_GENESIS_DIR"

View File

@ -1,71 +0,0 @@
#!/bin/bash
# Exit on error
set -e
set -u
# Check args
if [ "$#" -ne 3 ]; then
echo "Usage: $0 <stage0-deployment-dir-absolute> <participant-allocation> <validator-allocation>"
echo "Example: $0 /home/user/stage0-deployment 1000000 1000000000000"
exit 1
fi
STAGE0_DEPLOYMENT_DIR="$1"
PARTICIPANT_ALLOCATION="$2"
VALIDATOR_ALLOCATION="$3"
STAGE1_GENESIS_DIR=stage1-genesis
# Create a temporary target directory
mkdir -p $STAGE1_GENESIS_DIR
# --------
# Export participants from onboarding module state on stage0 laconicd chain
# Use cerc/laconicd-stage0:local image for stage0 laconicd build
stage1_participants_file="$STAGE1_GENESIS_DIR/stage1-participants.json"
docker run -it \
-v ${STAGE0_DEPLOYMENT_DIR}/data/laconicd-data:/root/stage0-deployment/.laconicd \
cerc/laconicd-stage0:local bash -c "laconicd export --home /root/stage0-deployment/.laconicd" \
| jq .app_state.onboarding.participants > "$stage1_participants_file"
stage1_participants=$(cat "$stage1_participants_file")
echo "Exported participants for stage1 onboarding module state"
# --------
# For each participant, using ETH account holdings, figure out balance allocation for stage1
stage1_allocations_file="$STAGE1_GENESIS_DIR/stage1-allocations.json"
jq -n --argjson participants "$stage1_participants" --arg participant_allocation "$PARTICIPANT_ALLOCATION" --arg validator_allocation "$VALIDATOR_ALLOCATION" '
[
$participants[] |
{
cosmos_address: .cosmos_address,
balance: (if .role == "validator" then $validator_allocation else $participant_allocation end)
}
]' > $stage1_allocations_file
echo "Calculated allocations for stage 1 chain"
# --------
# Run a script with cerc/laconicd:local to generate the genesis file
# with onboarding module state and given allocations
docker run -it \
-v ./$STAGE1_GENESIS_DIR:/root/.laconicd \
-v ./scripts:/scripts \
cerc/laconicd:local bash -c "/scripts/genesis.sh"
# Copy over the genesis file to output folder
OUTPUT_DIR=output
mkdir -p $OUTPUT_DIR
cp ./$STAGE1_GENESIS_DIR/config/genesis.json $OUTPUT_DIR/genesis.json
echo "Genesis file for stage1 written to $OUTPUT_DIR/genesis.json"
# --------
# Clean up
echo "Please remove the temporary data directory: sudo rm -rf $STAGE1_GENESIS_DIR"

View File

@ -61,18 +61,18 @@ echo "Calculated allocations for stage 1 chain"
# Run a script with cerc/laconicd:local to generate the genesis file # Run a script with cerc/laconicd:local to generate the genesis file
# with onboarding module state and given allocations # with onboarding module state and given allocations
docker run -it \ docker run -it \
-v ./$STAGE1_GENESIS_DIR:/root/.laconicd \ -v ./stage1-genesis:/root/.laconicd \
-v ./scripts:/scripts \ -v ./scripts:/scripts \
cerc/laconicd:local bash -c "/scripts/genesis.sh" cerc/laconicd:local bash -c "/scripts/genesis.sh"
# Copy over the genesis file to output folder # Copy over the genesis file to output folder
OUTPUT_DIR=output OUTPUT_DIR=output
mkdir -p $OUTPUT_DIR mkdir -p $OUTPUT_DIR
cp ./$STAGE1_GENESIS_DIR/config/genesis.json $OUTPUT_DIR/genesis.json cp ./stage1-genesis/config/genesis.json $OUTPUT_DIR/genesis.json
echo "Genesis file for stage1 written to $OUTPUT_DIR/genesis.json" echo "Genesis file for stage1 written to $OUTPUT_DIR/genesis.json"
# -------- # --------
# Clean up # Clean up
echo "Please remove the temporary data directory: sudo rm -rf $STAGE1_GENESIS_DIR" echo "Please remove the temporary data directory: sudo rm -rf stage1-genesis"

View File

@ -1,80 +0,0 @@
#!/bin/bash
# Exit on error
set -e
set -u
CHAINID=${CHAINID:-"laconic-testnet-2"}
STAGE2_MONIKER=${MONIKER:-"localtestnet-stage-2"}
NODE_HOME="$HOME/.laconicd"
# Existing key
KEY="alice"
KEYRING=${KEYRING:-"test"}
DENOM=${DENOM:-"alnt"}
STAKING_AMOUNT=${STAKING_AMOUNT:-"1000000000000000"}
stage1_state="$NODE_HOME/stage1-state.json"
stage2_genesis_file="$NODE_HOME/config/genesis.json"
remove_module_accounts () {
bonded_tokens_pool_address=$(jq -r '.app_state.auth.accounts[] | select(.name == "bonded_tokens_pool") | .base_account.address' $stage2_genesis_file)
bonded_tokens_pool_balance=$(jq -r --arg ADDRESS "$bonded_tokens_pool_address" '( .app_state.bank.balances[]? | select(.address == $ADDRESS) | .coins[]? | select(.denom == "alnt") | .amount ) // "0"' $stage2_genesis_file)
not_bonded_tokens_pool_address=$(jq -r '.app_state.auth.accounts[] | select(.name == "not_bonded_tokens_pool") | .base_account.address' $stage2_genesis_file)
not_bonded_tokens_pool_balance=$(jq -r --arg ADDRESS "$not_bonded_tokens_pool_address" '( .app_state.bank.balances[]? | select(.address == $ADDRESS) | .coins[]? | select(.denom == "alnt") | .amount ) // "0"' $stage2_genesis_file)
distribution_address=$(jq -r '.app_state.auth.accounts[] | select(.name == "distribution") | .base_account.address' $stage2_genesis_file)
distribution_balance=$(jq -r --arg ADDRESS "$distribution_address" '( .app_state.bank.balances[]? | select(.address == $ADDRESS) | .coins[]? | select(.denom == "alnt") | .amount ) // "0"' $stage2_genesis_file)
# Remove the entry from auth.accounts
jq "del(.app_state.auth.accounts[] | select(.base_account.address == \"$bonded_tokens_pool_address\"))" $stage2_genesis_file > tmp.$$.json && mv tmp.$$.json $stage2_genesis_file
jq "del(.app_state.auth.accounts[] | select(.base_account.address == \"$not_bonded_tokens_pool_address\"))" $stage2_genesis_file > tmp.$$.json && mv tmp.$$.json $stage2_genesis_file
jq "del(.app_state.auth.accounts[] | select(.base_account.address == \"$distribution_address\"))" $stage2_genesis_file > tmp.$$.json && mv tmp.$$.json $stage2_genesis_file
# Remove the entry from bank.balances
jq "del(.app_state.bank.balances[] | select(.address == \"$bonded_tokens_pool_address\"))" $stage2_genesis_file > tmp.$$.json && mv tmp.$$.json $stage2_genesis_file
jq "del(.app_state.bank.balances[] | select(.address == \"$not_bonded_tokens_pool_address\"))" $stage2_genesis_file > tmp.$$.json && mv tmp.$$.json $stage2_genesis_file
jq "del(.app_state.bank.balances[] | select(.address == \"$distribution_address\"))" $stage2_genesis_file > tmp.$$.json && mv tmp.$$.json $stage2_genesis_file
# Subtract the balance from bank supply
bank_supply=$(jq -r '(.app_state.bank.supply[] | select(.denom == "alnt") | .amount)' $stage2_genesis_file)
new_supply=$(echo "$bank_supply - $bonded_tokens_pool_balance - $not_bonded_tokens_pool_balance - $distribution_balance" | bc)
# Update genesis file with the new amount
jq --arg NEW_SUPPLY "$new_supply" '(.app_state.bank.supply[] | select(.denom == "alnt") | .amount) |= $NEW_SUPPLY' $stage2_genesis_file > tmp.$$.json && mv tmp.$$.json $stage2_genesis_file
}
# Remove existing data but keep keys
laconicd cometbft unsafe-reset-all
# Remove existing genesis file and gentxs
rm -r $NODE_HOME/config/gentx || true
rm $stage2_genesis_file || true
# Initialize node with given chain id and moniker
laconicd config set client chain-id $CHAINID
laconicd init $STAGE2_MONIKER --chain-id $CHAINID --default-denom alnt
# Import required module state
jq --slurpfile nested $stage1_state '.app_state.auth = $nested[0].app_state.auth' "$stage2_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage2_genesis_file"
jq --slurpfile nested $stage1_state '.app_state.bank = $nested[0].app_state.bank' "$stage2_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage2_genesis_file"
jq --slurpfile nested $stage1_state '.app_state.bond = $nested[0].app_state.bond' "$stage2_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage2_genesis_file"
jq --slurpfile nested $stage1_state '.app_state.onboarding = $nested[0].app_state.onboarding' "$stage2_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage2_genesis_file"
jq --slurpfile nested $stage1_state '.app_state.registry = $nested[0].app_state.registry' "$stage2_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage2_genesis_file"
# Remove bonded_tokens_pool, not_bonded_tokens_pool distribution module accounts as we're skipping their state
remove_module_accounts
# Set all account sequences to 0
jq '(.app_state.auth.accounts[] | select(has("sequence")) | .sequence) = "0"' "$stage2_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage2_genesis_file"
# Sign genesis transaction
# 10^15 alnt
laconicd genesis gentx $KEY $STAKING_AMOUNT$DENOM --keyring-backend $KEYRING --chain-id $CHAINID
# Collect genesis txs
laconicd genesis collect-gentxs
# Run this to ensure everything worked and that the genesis file is setup correctly
laconicd genesis validate

View File

@ -6,31 +6,24 @@ set -u
# Note: Needs to be run in a docker container with image cerc/laconicd:local # Note: Needs to be run in a docker container with image cerc/laconicd:local
CHAINID=${CHAINID:-"laconic_9000-1"} CHAINID="laconic_9000-1"
STAGE1_MONIKER=${MONIKER:-"localtestnet-stage-1"} STAGE1_MONIKER=localtestnet-stage-1
NODE_HOME="/root/.laconicd" NODE_HOME="/root/.laconicd"
stage1_participants_file="$NODE_HOME/stage1-participants.json" onboarding_state_file="$NODE_HOME/stage0-onboarding-state.json"
stage1_allocations_file="$NODE_HOME/stage1-allocations.json" stage1_allocations_file="$NODE_HOME/stage1-allocations.json"
stage1_genesis_file="$NODE_HOME/config/genesis.json" stage1_genesis_file="$NODE_HOME/config/genesis.json"
laconicd init $STAGE1_MONIKER --chain-id $CHAINID --default-denom alnt laconicd init $STAGE1_MONIKER --chain-id $CHAINID --default-denom alnt
# Update onboarding module state with participants # Update onboarding module state with participants from stage0
jq --argfile p "$stage1_participants_file" '.app_state.onboarding.participants = $p' "$stage1_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage1_genesis_file" participants=$(jq -c '.participants' $onboarding_state_file)
jq --argjson p "$participants" '.app_state.onboarding.participants = $p' "$stage1_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage1_genesis_file"
# Disable bank module transfers # Disable bank module transfers
# jq '.app_state["bank"]["params"]["default_send_enabled"]=false' "$stage1_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage1_genesis_file" jq '.app_state["bank"]["params"]["default_send_enabled"]=false' "$stage1_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage1_genesis_file"
# Update staking module params
jq '.app_state["staking"]["params"]["max_validators"]=100' "$stage1_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage1_genesis_file"
# Update slashing module params
jq '.app_state["slashing"]["params"]["signed_blocks_window"]="2400"' "$stage1_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage1_genesis_file"
jq '.app_state["slashing"]["params"]["min_signed_per_window"]="0.5"' "$stage1_genesis_file" > tmp.$$.json && mv tmp.$$.json "$stage1_genesis_file"
# Read and assign allocations # Read and assign allocations
echo "Adding genesis accounts with allocations..."
jq -c '.[]' "$stage1_allocations_file" | while IFS= read -r line; do jq -c '.[]' "$stage1_allocations_file" | while IFS= read -r line; do
cosmos_address=$(jq -r '.cosmos_address' <<< "$line") cosmos_address=$(jq -r '.cosmos_address' <<< "$line")
balance=$(jq -r '.balance' <<< "$line") balance=$(jq -r '.balance' <<< "$line")

View File

@ -1,25 +0,0 @@
#!/bin/bash
# Exit on error
set -e
# Prerequisite: stage1 exported state present at $STAGE2_DEPLOYMENT/data/laconicd-data/stage1-state.json
# Check args
if [ "$#" -lt 2 ]; then
echo "Usage: $0 <stage2-deployment-dir> <stage2-chain-id> <node-moniker> <node-keyring-backend> [node-staking-amount]"
echo "Example: $0 /srv/stage2-deployment laconic-testnet-2 LaconicStage2 os 1000000000000000"
exit 1
fi
STAGE2_DEPLOYMENT=$1
CHAINID=$2
MONIKER=$3
KEYRING=$4
STAKING_AMOUNT=$5
# Generate genesis file for state2 chain and init node
docker run -it \
-v $STAGE2_DEPLOYMENT/data/laconicd-data:/root/.laconicd \
-v ./scripts:/scripts \
cerc/laconicd:local bash -c "CHAINID=$CHAINID MONIKER=$MONIKER KEYRING=$KEYRING STAKING_AMOUNT=$STAKING_AMOUNT /scripts/generate-stage2-genesis.sh"

View File

@ -2,7 +2,7 @@ version: "1.0"
name: fixturenet-laconicd name: fixturenet-laconicd
description: "A laconicd fixturenet" description: "A laconicd fixturenet"
repos: repos:
- git.vdb.to/cerc-io/laconicd@v0.1.9 - git.vdb.to/cerc-io/laconicd
containers: containers:
- cerc/laconicd - cerc/laconicd
pods: pods: